
package jhtx16wx;

import javax.sound.midi.MidiDevice;
import javax.sound.midi.MidiDevice.Info;
import javax.sound.midi.MidiMessage;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.Receiver;
import javax.sound.midi.ShortMessage;
import static javax.sound.midi.ShortMessage.NOTE_OFF;
import static javax.sound.midi.ShortMessage.NOTE_ON;

public class JHTX16WX {

    public static void main(String alf[]) {
        try {
            MidiMessage onMessage = new ShortMessage(NOTE_ON, 0, 45, 64);
            MidiMessage offMessage = new ShortMessage(NOTE_OFF, 0, 45, 64);
    
            Info infos[] = MidiSystem.getMidiDeviceInfo();
            for (Info info : infos) {
                System.out.println("");
                System.out.println("info: " + info);
                System.out.println("info.getDescription(): " + info.getDescription());
                System.out.println("info.getName(): " + info.getName());
                System.out.println("info.getVendor(): " + info.getVendor());
                System.out.println("info.getVersion(): " + info.getVersion());
                MidiDevice device = MidiSystem.getMidiDevice(info);
                System.out.println("device.toString(): " + device.toString());
                try {
                    if ((info.getName().equals("loopMIDI Port") && device.toString().contains("MidiOutDevice"))) {
                        if (!device.isOpen()) {
                            device.open();
                        }
                        Receiver r = device.getReceiver();
                        int k = 43;
                        for (int j = 0; j < 100; j++) {
                            onMessage = new ShortMessage(NOTE_ON, 0, k, 64);
                            offMessage = new ShortMessage(NOTE_OFF, 0, k, 64);
                            k--;
                            if (k < 40) {
                                k = 43;
                            }
                            r.send(onMessage, -1);
                            Thread.sleep(1000);
                            r.send(offMessage, -1);
                            Thread.sleep(11307);
                        }

                        device.close();
                    }
                    device.close();
                } catch (Exception e2) {
                    System.out.println("exception opening device: " + e2);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
